diff -uNr dahdi-linux-2.3.0.ORIG//drivers/dahdi/xpp/xpp_usb.c dahdi-linux-2.3.0/drivers/dahdi/xpp/xpp_usb.c
--- dahdi-linux-2.3.0.ORIG//drivers/dahdi/xpp/xpp_usb.c	2010-05-24 17:07:57.000000000 +0100
+++ dahdi-linux-2.3.0/drivers/dahdi/xpp/xpp_usb.c	2010-05-24 17:13:34.000000000 +0100
@@ -308,7 +308,11 @@
 		return NULL;
 	}
 	usb_init_urb(&uframe->urb);
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,34)
 	p = usb_buffer_alloc(xusb->udev, size, gfp_flags, &uframe->urb.transfer_dma);
+#else
+	p = usb_alloc_coherent(xusb->udev, size, gfp_flags, &uframe->urb.transfer_dma);
+#endif
 	if(!p) {
 		if((rate_limit++ % 1003) == 0)
 			XUSB_ERR(xusb, "buffer allocation failed (%d)\n", rate_limit);
@@ -330,9 +334,15 @@
 
 	BUG_ON(xbus->transport.priv != uframe->xusb);
 	//XUSB_INFO(uframe->xusb, "frame_free\n");
+#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,34)
 	usb_buffer_free(urb->dev, uframe->transfer_buffer_length,
 			urb->transfer_buffer,
 			urb->transfer_dma);
+#else
+	usb_free_coherent(urb->dev, uframe->transfer_buffer_length,
+			urb->transfer_buffer,
+			urb->transfer_dma);
+#endif
 	memset(uframe, 0, sizeof(*uframe));
 	kmem_cache_free(xusb_cache, uframe);
 }
